unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, EnergyNN;
 const
  TRAINING_DATA_COUNT = 24;
type
  TForm1 = class(TForm)
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  NeuralNet: TNeuralNetwork;
  Inputs: DynAR2;
  ExpectedOutputs: array of Double;
  i: Integer;
begin
    SetLength(Inputs, TRAINING_DATA_COUNT, INPUT_NEURONS);
    SetLength(ExpectedOutputs, TRAINING_DATA_COUNT);

  //   
  for i := 0 to TRAINING_DATA_COUNT - 1 do
  begin
    Inputs[i][0] := i;               // x
    Inputs[i][1] := Random * 70 - 30; // y
    Inputs[i][2] := Random * 40;      // z
    Inputs[i][3] := Random * 5 + 40;  // h
    ExpectedOutputs[i] := Random * 100; // 
  end;

  NeuralNet := TNeuralNetwork.Create;
  NeuralNet.Train(Inputs, ExpectedOutputs,24);

  //  
  var TestInput: array of Double;
  SetLength(TestInput, INPUT_NEURONS);
  TestInput[0] := 12;
  TestInput[1] := 20;
  TestInput[2] := 5;
  TestInput[3] := 42;

  var Prediction := NeuralNet.Predict(TestInput);
  //Writeln('Predicted energy consumption: ', Prediction:0:2);


end;

end.
